#! /usr/bin/env python
## greeklish2greek.py
##
## Copyright (C) 2006 Nikos Kouremenos <kourem@gmail.com>
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published
## by the Free Software Foundation; version 2 only.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##

import urllib
import urllib2
import signal
import sre

import gtk
import gtk.glade

def decode_html(html):
	s = sre.sub('&#([Xx]?)([0-9]+);', lambda m: unichr(int(m.group(2),
		(16, 10)[m.group(1) == ''])), html)
	return s


class Greeklish2Greek:
	
	def __init__(self):
		xml = gtk.glade.XML('greeklish2greek.glade', 'window')
		self.window = xml.get_widget('window')
		self.input_textbuffer = xml.get_widget('input_textview').get_buffer()
		self.output_textbuffer = xml.get_widget('output_textview').get_buffer()
		
		#self.window.show_all()
		self.window.show()
		xml.signal_autoconnect(self)
	
	def on_close_button_clicked(self, widget):
		self.window.destroy()

	def on_window_delete_event(self, widget, event):
		gtk.main_quit()

	def on_to_greek_button_clicked(self, widget):
		start_iter, finish_iter = self.input_textbuffer.get_bounds()
		input_ = self.input_textbuffer.get_text(start_iter, finish_iter)
		self.do_conversion(input_, 'greeklish2greek')
	
	def on_to_greeklish_button_clicked(self, widget):
		start_iter, finish_iter = self.input_textbuffer.get_bounds()
		input_ = self.input_textbuffer.get_text(start_iter, finish_iter)
		self.do_conversion(input_, 'greek2greeklish')
	
	def do_conversion(self, input_, mode):
		self.output_textbuffer.set_text('')
		input_ = input_.replace('\n', ' ') # how they do \n?? :(
		while len(input_) > 255:
			i = 255
			while input_[i] != ' ':
				i -= 1
				if i == 0:
					print 'WORD is more than 255 NOTHING I CAN DO'
					return
					
			phrase_to_send = input_[:i]
			input_ = input_[i:]
			result = self.get_result(phrase_to_send, mode) + ' '
			end_iter = self.output_textbuffer.get_end_iter()
			self.output_textbuffer.insert(end_iter, result)
		else:
			result = self.get_result(input_, mode)
			end_iter = self.output_textbuffer.get_end_iter()
			self.output_textbuffer.insert(end_iter, result)
	
	def get_result(self, input_, mode):
		# mode can be 'greek2greeklish' or 'greeklish2greek'
		url = 'http://speech.ilsp.gr/greeklish/greeklishdemo.asp'
		if mode == 'greek2greeklish':
			params = {'sIN': '', 'gl2g.x': 42, 'gl2g.y': 15, 'sOUT': input_}
		else:
			params = {'sIN': input_, 'gl2g.x': 42, 'gl2g.y': 15}
		txdata = urllib.urlencode(params) 
		txheaders = {
			'User-agent' : 'Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.7)',
			'Referer' : url
				}

		try:
			req = urllib2.Request(url, txdata, txheaders)
			handle = urllib2.urlopen(req)
		except IOError, e:
			print 'We failed to open "%s".' % url
			if hasattr(e, 'code'):
				print 'We failed with error code - %s.' % e.code
			return

		lines = handle.readlines()
		for line in lines:
			if mode == 'greeklish2greek':
				if line.startswith('    <textarea name="sOUT"'):
					start_idx = line.find('rows="1">') + 9 # len('rows="1">') = 9
					finish_idx = line.find('</textarea>', start_idx)
					result = line[start_idx:finish_idx].decode('iso-8859-7')
					return result
			elif mode == 'greek2greeklish':
				if line.startswith('            <td height="187" colspan="2" width="273"><textarea name="sIN"'):
					start_idx = line.find('rows="1">') + 9 # len('rows="1">') = 9
					finish_idx = line.find('</textarea>', start_idx)
					result = line[start_idx:finish_idx]
					print 'RETURNING greeklish', result
					return decode_html(result)

if __name__ == '__main__':
	signal.signal(signal.SIGINT, signal.SIG_DFL) # ^C exits the application

	try: # Import Psyco if available
		import psyco
		psyco.full()
	except ImportError:
		pass
	
	Greeklish2Greek()
	gtk.main()
